#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASListMemberGroup : public CWASCommand
{
public:
	CWASListMemberGroup(CWASActor *pActor);
	~CWASListMemberGroup(void);

	void ExecuteAsync(void);
	
	void SetParameter(int nGroupType, LPCWSTR strCustcoID, LPCWSTR strTenant, LPCWSTR strLangCode)
	{
		m_nGroupType = nGroupType;
		m_wsCustcoID = strCustcoID;
		m_wsTenant = strTenant;
		m_wsLangCode = strLangCode;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:

	int m_nGroupType;
	WSTRING m_wsCustcoID;
	WSTRING m_wsTenant;
	WSTRING m_wsLangCode;

	//p_buddygrouplist_t m_listMemberGroupPrivate;
	//buddygrouplist_t m_listMemberGroup;
	std::vector<GT_ORG_GROUP_DATA> m_listMemberGroupPrivate;
	std::vector<GT_ORG_GROUP_DATA> m_listMemberGroup;
};
